require "behaviours/follow"
require "behaviours/wander"
require "behaviours/faceentity"
require "behaviours/panic"


local MIN_FOLLOW_DIST = 3
local MAX_FOLLOW_DIST = 12
local TARGET_FOLLOW_DIST = 6

local MAX_WANDER_DIST = 3


local function GetFaceTargetFn(inst)
    return inst.components.follower.leader
end

local function KeepFaceTargetFn(inst, target)
    return inst.components.follower.leader == target
end


local rat_whitebrain = Class(Brain, function(self, inst)
    Brain._ctor(self, inst)
end)







local KEEP_CHOPPING_DIST = 7
local KEEP_CHOPPING_DIST_PLAYER_FAR = 30
local SEE_TREE_DIST = 20

local function KeepChoppingAction(inst)
local ghost = inst
	if inst.components.follower.leader and inst.components.follower.leader:GetDistanceSqToInst(inst) <= KEEP_CHOPPING_DIST*KEEP_CHOPPING_DIST then
		inst:AddTag("choppingrat")
		else
		inst:RemoveTag("choppingrat")
	end
		return inst.components.follower.leader and inst.components.follower.leader:GetDistanceSqToInst(inst) <= KEEP_CHOPPING_DIST*KEEP_CHOPPING_DIST
end

local function StartChoppingCondition(inst)
local ghost = inst

		
		return inst.components.follower.leader and inst.components.follower.leader.sg and inst.components.follower.leader.sg:HasStateTag("chopping")
		
end


local function FindTreeToChopAction(inst)
    local target = FindEntity(inst, SEE_TREE_DIST, function(item) return item.components.workable and (item.components.workable.action == ACTIONS.CHOP) end)
    if target then
			inst.components.knownlocations:RememberLocation("treetarg", Vector3(target.Transform:GetWorldPosition()) )
			local chestpos = inst.components.knownlocations:GetLocation("treetarg")
			print("chestpos x "..chestpos.x)
			return BufferedAction(inst, nil, ACTIONS.WALKTO, nil, chestpos, nil, 0.2)	
    end
end







function rat_whitebrain:OnStart()
    local root = 
    PriorityNode({
        WhileNode( function() return self.inst.components.health.takingfiredamage end, "OnFire", Panic(self.inst)),
		
        IfNode(function() return StartChoppingCondition(self.inst) end, "chop", 
           WhileNode(function() return KeepChoppingAction(self.inst) end, "keep chopping",
                LoopNode{ 
                    
                     DoAction(self.inst, FindTreeToChopAction )})),		
		
        Follow(self.inst, function() return self.inst.components.follower.leader end, MIN_FOLLOW_DIST, TARGET_FOLLOW_DIST, MAX_FOLLOW_DIST),
    --    Wander(self.inst, function() return self.inst.components.knownlocations:GetLocation("home") end, MAX_WANDER_DIST*1.5)
		
       --- FaceEntity(self.inst, GetFaceTargetFn, KeepFaceTargetFn),
        
    }, .25)
    self.bt = BT(self.inst, root)
end

return rat_whitebrain