local prefabs = 
{
	"ant",
	--"killerbee",
    "flint",
   -- "honeycomb",
}

local assets =
{
    Asset("ANIM", "anim/anthill.zip"),
	Asset("SOUND", "sound/bee.fsb"),
}


local function OnEntityWake(inst)
    inst.SoundEmitter:PlaySound("dontstarve/bee/bee_hive_LP", "loop")
end

local function OnEntitySleep(inst)
	inst.SoundEmitter:KillSound("loop")
end

local function StartSpawning(inst)
	if inst.components.childspawner 
            and (GetSeasonManager() and not GetSeasonManager():IsWinter()) 
            and not (inst.components.freezable and inst.components.freezable:IsFrozen()) then
		inst.components.childspawner:StartSpawning()
		inst.components.childspawner:ReleaseAllChildren()
	end
end

local function StopSpawning(inst)
	if inst.components.childspawner then
		inst.components.childspawner:StopSpawning()
	end
end




local function OnKilled(inst)
    inst:RemoveComponent("childspawner")
    inst.AnimState:PlayAnimation("low", true)
end


local function fn(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
	
    MakeObstaclePhysics(inst, .5)

	local minimap = inst.entity:AddMiniMapEntity()
	minimap:SetIcon( "beehive.png" )

	anim:SetBank("anthill")
	anim:SetBuild("anthill")
	anim:PlayAnimation("full", true)

    inst:AddTag("structure")
	inst:AddTag("hive")
    
    -------------------
	inst:AddComponent("health")
    inst.components.health:SetMaxHealth(1000)

    -------------------
	inst:AddComponent("childspawner")
	inst.components.childspawner.childname = "ant"
	inst.components.childspawner:SetRegenPeriod(TUNING.BEEHIVE_REGEN_TIME)
	inst.components.childspawner:SetSpawnPeriod(15)
	inst.components.childspawner:SetMaxChildren(4)

    StartSpawning(inst)

    inst:ListenForEvent("dusktime", function() StartSpawning(inst) end, GetWorld())
    inst:ListenForEvent("daytime", function() StartSpawning(inst) end , GetWorld())
	
    ---------------------  
    inst:AddComponent("lootdropper")
    inst.components.lootdropper:SetLoot({"flint"})
    ---------------------  

	
	
	inst:AddComponent("lootdropper")
	inst.components.lootdropper.numrandomloot = 1
	inst.components.lootdropper:AddRandomLoot("rocks", 4)
	inst.components.lootdropper:AddRandomLoot("nitre", 1.5)
	inst.components.lootdropper:AddRandomLoot("goldnugget", .5)
	inst.components.lootdropper:AddRandomLoot("flint", 1.5)

	inst:AddComponent("inventory")
	inst.components.inventory.maxslots = 50
	
	
    ---------------------        
   -- MakeLargeBurnable(inst)
 --   inst.components.burnable:SetOnIgniteFn(OnIgnite)
    -------------------
    
    ---------------------
    --MakeMediumFreezableCharacter(inst)
--    inst:ListenForEvent("freeze", OnFreeze)
  --  inst:ListenForEvent("onthaw", OnThaw)
   -- inst:ListenForEvent("unfreeze", OnUnFreeze)
    -------------------

    
    ---------------------       
    MakeLargePropagator(inst)
	
    ---------------------
    
    inst:AddComponent("inspectable")
	inst.OnEntitySleep = OnEntitySleep
	inst.OnEntityWake = OnEntityWake
    
    
    
	return inst
end

return Prefab( "forest/monsters/anthive", fn, assets, prefabs ) 

