require "stategraphs/SGrabbit"

local assets=
{
	Asset("ANIM", "anim/rat.zip"),
	Asset("ANIM", "anim/rat_white.zip"),
	Asset("SOUND", "sound/rabbit.fsb"),
}

local prefabs =
{
    "smallmeat",
    "cookedsmallmeat",
    "beardhair",
}

local rabbitsounds = 
{
    scream = "dontstarve/rabbit/scream",
    hurt = "dontstarve/rabbit/scream_short",
}


local function onpickup(inst)
end


local function ondrop(inst)
	inst.SoundEmitter:PlaySound("dontstarve/rabbit/scream")
end




local function OnWake(inst)
-------	inst.checktask = inst:DoPeriodicTask(10, CheckTransformState)
end

local function OnSleep(inst)
	 if inst.checktask then
	 	inst.checktask:Cancel()
	 	inst.checktask = nil
	 end
end

local function GetCookProductFn(inst)
	if inst.israbbit or inst.iswinterrabbit then
		return "cookedsmallmeat" 
	else 
		return "cookedmonstermeat"
	end
end

local function OnCookedFn(inst)
	inst.SoundEmitter:PlaySound("dontstarve/rabbit/scream_short")

end

local function OnAttacked(inst, data)
    local x,y,z = inst.Transform:GetWorldPosition()
    local ents = TheSim:FindEntities(x,y,z, 30, {'rat'})
    
    local num_friends = 0
    local maxnum = 3
    for k,v in pairs(ents) do
        v:PushEvent("gohome")
        num_friends = num_friends + 1
        
        if num_friends > maxnum then
            break
        end
    end
end



local function updatedamage(inst)
    if not GetClock():IsDay() then
		inst.components.sleeper:WakeUp()
    end
end




local function onsave(inst, data)

	data.ispet = inst.ispet
	data.twigsvalue = inst.twigsvalue
end

local function onload(inst, data)
	inst.ispet = data.ispet or false
	inst.twigsvalue = data.twigsvalue or 3
end




local function fn(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
    local physics = inst.entity:AddPhysics()
	local sound = inst.entity:AddSoundEmitter()
	local shadow = inst.entity:AddDynamicShadow()
	shadow:SetSize( 1, .75 )
    inst.Transform:SetFourFaced()

    MakeCharacterPhysics(inst, 1, 0.5)
	
	inst.ispet = false
	inst.twigsvalue = 3
	
    inst.OnSave = onsave
    inst.OnLoad = onload	

	inst:AddComponent("follower")
    inst.components.follower.maxfollowtime = 9999999999
	local brain = require "brains/ratbrain"

--[[	if GetPlayer().components.inventory:Has("cutgrass", 1) then
		inst.ispet = true
	end--]]
	if inst.ispet == true then
		anim:SetBank("rat_white")
		anim:SetBuild("rat_white")
		anim:PlayAnimation("idle")
		
		
	else
		anim:SetBank("rat")
		anim:SetBuild("rat")
		anim:PlayAnimation("idle")
	end
    inst:AddComponent("locomotor") -- locomotor must be constructed before the stategraph
    inst.components.locomotor.runspeed = TUNING.RABBIT_RUN_SPEED*0.8
    inst:SetStateGraph("SGrat")

    inst:AddTag("animal")
    inst:AddTag("prey")
    inst:AddTag("rat")
    inst:AddTag("smallcreature")
    inst:AddTag("canbetrapped")    

    inst:SetBrain(brain)
    
    inst.data = {}
	
	inst.Transform:SetScale(1.2, 1.2, 1.2)
	
		inst.sounds = rabbitsounds

		inst:AddComponent("eater")

	inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.nobounce = true
	inst.components.inventoryitem.canbepickedup = false
	inst.components.inventoryitem:SetOnPickupFn(onpickup)
	inst.components.inventoryitem.atlasname = "images/inventoryimages/rat.xml"
	
	
	inst:AddComponent("sanityaura")
    

    inst:AddComponent("cookable")
    inst.components.cookable.product = "cookedsmallmeat"
    inst.components.cookable:SetOnCookedFn(OnCookedFn)

    
    inst:AddComponent("knownlocations")
    inst:AddComponent("combat")
    inst.components.combat.hiteffectsymbol = "chest"
    inst:AddComponent("health")
    inst.components.health:SetMaxHealth(TUNING.RABBIT_HEALTH)
    inst.components.health.murdersound = "dontstarve/rabbit/scream_short"
    
    MakeSmallBurnableCharacter(inst, "chest")
    MakeTinyFreezableCharacter(inst, "chest")

    inst:AddComponent("lootdropper")
	inst.components.lootdropper:SetLoot({"smallmeat"})


	inst:AddComponent("inspectable")
    inst:AddComponent("sleeper")


		local SEE_DIST = 50
		local TOOCLOSE = 6



	
	inst.OnEntityWake = OnWake
	inst.OnEntitySleep = OnSleep    
    
	inst:AddComponent("talker")
   -- inst.components.talker.ontalk = ontalk
    inst.components.talker.fontsize = 28
    inst.components.talker.font = TALKINGFONT
    inst.components.talker.colour = Vector3(1,0.3,0.3)
    inst.components.talker.offset = Vector3(0,-45,0)
    inst.components.talker:StopIgnoringAll()
    inst:AddComponent("homeseeker")
	
	
	inst:DoPeriodicTask(math.random(25,45), function()
		--print("rat talk attem")
		if GetPlayer().components.sanity:GetPercent()<0.5 and not inst.components.sleeper:IsAsleep() then-- and ((inst.components.homeseeker and 
       --inst.components.homeseeker.home and inst.components.homeseeker.home:IsValid() and inst:GetDistanceSqToInst(inst.components.homeseeker.home)>1) or inst.components.homeseeker and 
       --not inst.components.homeseeker.home) then
		print("RAT TALKS !! FFS")
        local words = {"Rat comes for you.", "lol", "Why so serious?","Gotta screw you.","Do u even rat?","You mad bro.","Rats do not talk.",
		"Something wrong?", "Hey!","Leave some food for me.","Are you mad?","Oh c'mon.","Just ignore this madman. Just... ignore.",
		"We pray at night. We stalk at night.","Who is rat here?","Look! A dinner for as!","The rat is... real!", "Dude, you need help.","What rats ever did to you?",
		"Watch out your chests!","The Great Rat will someday come...","We all wait for the Great Rat.","The Great Rat will find you."}
		local word = words[math.random(#words)]
		--print(word)
        inst.components.talker:Say(word, math.random(3,6), false)
		end

	end)

	
	
    inst.OnSave = function(inst, data)
        if not inst.israbbit then
			data.israbbit = inst.israbbit
		end
        data.iswinterrabbit = inst.iswinterrabbit or nil
    end        
    
    inst:ListenForEvent( "dusktime", function() updatedamage(inst) end , GetWorld())
    inst:ListenForEvent( "nighttime", function() updatedamage(inst) end , GetWorld())
	
	if GetPlayer().components.moisture then
		MakeFeedablePet(inst, TUNING.TOTAL_DAY_TIME*3, nil, ondrop)
	else
		inst.components.inventoryitem:SetOnDroppedFn(ondrop)
	end

    inst:ListenForEvent("attacked", OnAttacked)

	
	if inst.ispet == true then
		brain = require "brains/rat_whitebrain"
		inst:SetBrain(brain)
	    inst.components.health:SetMaxHealth(TUNING.RABBIT_HEALTH*2)
		GetPlayer().components.leader:AddFollower(inst)
        inst.components.follower:AddLoyaltyTime(9999999999)
		inst.components.locomotor.runspeed = TUNING.RABBIT_RUN_SPEED*1.1
		
		
		inst:DoPeriodicTask(math.random(40,80), function()
			inst.twigsvalue = inst.twigsvalue+1
		end)
		
		inst:DoPeriodicTask(math.random(2,4), function()
		if inst:HasTag("choppingrat") and inst.twigsvalue>0 then
			local target = FindEntity(inst, SEE_DIST, function(item) 
				if item.components.workable and item.components.workable.action == ACTIONS.CHOP then
						return GetPlayer() and GetPlayer():GetDistanceSqToInst(item) < 7*7
					end
				end)
			if target and inst:GetDistanceSqToInst(target) < 1.6 and math.random()<0.75 then
	
				print("EAT DAT TREE")
				inst.sg:GoToState("grz")
				local tree = target
				----EATING CHEST
				local twigs = SpawnPrefab("twigs")
				twigs.Transform:SetPosition(inst:GetPosition():Get())
			
				inst.twigsvalue = inst.twigsvalue-1
			
				inst.sg:GoToState("grz")
			end
		end
		end)
		
	else
	
	inst:DoPeriodicTask(math.random(2,4), function()
	
		local target = FindEntity(inst, SEE_DIST, function(item) 
			if item.prefab == "treasurechest" and 
				item.components.container and not item.grz == true and
				not item.components.container:IsEmpty() then
					return GetPlayer() and GetPlayer():GetDistanceSqToInst(item) > TOOCLOSE*TOOCLOSE
				end
			end)
		if target and inst:GetDistanceSqToInst(target) < 2 and inst:GetDistanceSqToInst(target) >0.03 then

			print("EAT DAT CHEST")
			inst.sg:GoToState("grz")
			local chest = target
			----EATING CHEST
				local rand = chest.components.container:GetItemInSlot(math.random(1,9))
				if rand then
					chest.components.container:DropItem(rand)
				end
			SpawnPrefab("collapse_small").Transform:SetPosition(chest.Transform:GetWorldPosition())
			chest.AnimState:PlayAnimation("hit")
			chest.AnimState:SetMultColour(0.5,.5,.5,1)
			chest.grz = true
			inst.sg:GoToState("grz")
		end
	end)

	end

	
	
	
    return inst
end

return Prefab( "forest/animals/rat", fn, assets, prefabs) 
